HDU 4336 Card Collector(状态压缩+概率DP)

传送门

In your childhood, do you crazy for collecting the beautiful cards in the snacks? They said that, for example, if you collect all the 108 people in the famous novel Water Margin, you will win an amazing award.

As a smart boy, you notice that to win the award, you must buy much more snacks than it seems to be. To convince your friends not to waste money any more, you should find the expected number of snacks one should buy to collect a full suit of cards.
 

Input
The first line of each test case contains one integer N (1 <= N <= 20), indicating the number of different cards you need the collect. The second line contains N numbers p1, p2, …, pN, (p1 + p2 + … + pN <= 1), indicating the possibility of each card to appear in a bag of snacks.

Note there is at most one card in a bag of snacks. And it is possible that there is nothing in the bag.
 

Output
Output one number for each test case, indicating the expected number of bags to buy to collect all the N different cards.

You will get accepted if the difference between your answer and the standard answer is no more that 10^-4.
 

Sample Input
1 0.1 2 0.1 0.4
 

Sample Output
10.000 10.500

题目大意:

还记得小时候吃的干脆面吗,干脆面包里面有一个卡片,我们收集一套卡片需要吃好多的干脆面,现在一套卡片有 N 张,现在给出一包干脆面里出现第 ai 种卡片的概率为 pi ,现在求吃多少包干脆面才能收集一套卡片,也就是求收集一套卡片的期望包数。

解题思路:

因为卡片出现的概率不一样,所以没有办法直接求,那么观察数据范围 N20 ,那么可以考虑状态压缩,设 dp[i]: i  1  , 那么有如下公式成立:

dp[i]=p1dp[i]+i&(1<<k)=0dp[i|(1<<k)]

其中 p1 表示+0
解释一下:假设 i=6 ,那么有它的二进制表示为 110 ,显然它已经有第 1 和 第 2 种卡片,所以 dp[6]=(+p[1]+p[2])dp[6]+p[3]dp[7]

初始化 dp[(1<<n)1]=0

代码:

#include <iostream>
#include <string.h>
#include <string>
#include <algorithm>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <map>
using namespace std;
typedef long long LL;
const int MAXN = 1048576+5;
const double PI = acos(-1);
const double eps = 1e-8;
const LL MOD = 1e9+7;
double dp[MAXN], p[22];
int main(){
    //freopen("C:/Users/yaonie/Desktop/in.txt", "r", stdin);
    //freopen("C:/Users/yaonie/Desktop/out.txt", "w", stdout);
    int n;
    while(~scanf("%d", &n)){
        p[0] = 0;
        double t = 1;//包里表示没有卡的概率
        for(int i=0; i<n; i++) scanf("%lf",&p[i]), t -= p[i];
        int all = (1<<n);
        dp[all-1] = 0;
        for(int i=all-2; i>=0; i--){
            double t1 = 0, t2 = 0;
            for(int j=0; j<n; j++){
                if(i&(1<<j)) t2 += p[j];
                else t1 += p[j]*dp[i|(1<<j)];
            }
            dp[i] = (t1+1)/(1-t2-t);
        }
        printf("%.5f\n",dp[0]);
    }
    return 0;
}
發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章